//run multiple tests
import java.io.*;
import java.util.*;

public class speechExperiment extends CANTExperiment {

  public speechExperiment () {
    trainingLength = 0; 
    inTest = true;
  }
  
  public boolean experimentDone (int Step) {
    if (speechCANT23.epoch > 720) return true;
    return (false);  
  }
  public void switchToTest () {
    System.out.println("swithctotest ");
    inTest = true;
  }
  
  public boolean isEndEpoch(int currentStep) {
    speechNet baseNet = (speechNet) getNet("BaseNet");
    if (currentStep >= (baseNet.time * baseNet.stepsPerInput))
      return (true);
    
    return (false);
  }  

  int cRight = 0;
  int cWrong = 0;
  int cOdd = 0;
  private void printResult() {
    System.out.print("Epoch " + speechCANT23.epoch + " ");
    int guess = 0;  //0 no guess, 1 a, 2 e, 3u

    System.out.print(aCount + " " + eCount + " " + uCount);

    if ((aCount == 0) && (eCount == 0) && (uCount == 0)) 
      guess = 0;
    else if ((aCount > eCount) && (aCount > uCount)) 
      guess = 1;
    else if ((eCount > aCount) && (eCount > uCount)) 
      guess = 2;
    else if ((uCount > aCount) && (uCount > eCount)) 
      guess = 3;
    else if ((aCount > eCount) && (aCount == uCount)) 
      guess = 1;
    else if ((aCount > uCount) && (aCount == eCount)) 
      guess = 1;
    else if ((aCount == uCount) && (aCount == eCount)) 
      guess = 1;
    else if ((eCount > uCount) && (aCount == eCount)) 
      guess = 2;
    else guess = 3;

    if (guess == 1) {
      System.out.print("It's an A ");
      if ((speechCANT23.epoch % 3) == 1) cRight++;
      else cWrong ++;
      }
    else if (guess == 2){
      System.out.print("It's an E ");
      if ((speechCANT23.epoch % 3) == 2 ) cRight++;
      else cWrong ++;
      }
    else if (guess == 3){
      System.out.print("It's a U ");
      if ((speechCANT23.epoch % 3) == 0) cRight++;
      else cWrong ++;
      }
    else
      {
      System.out.print("It's an odd result guess U");
      cOdd++;
      //guess U
      if ((speechCANT23.epoch % 3) == 0) cRight++;
      else cWrong ++;
      }

    System.out.println(cRight + " " + cWrong + " " +cOdd);

    aCount = eCount = uCount = 0;
  }

  public void endEpoch() {
      //    System.out.println("Gracefully Stop o");

    printResult();
    Enumeration eNum = CANT23.nets.elements();
    CANTNet net;
    do	{
      net = (CANTNet)eNum.nextElement();
      net.clear();
    }
    while (eNum.hasMoreElements());
    
    speechCANT23.epoch ++;
    speechCANT23.CANTStep = 0;
    speechNet baseNet = (speechNet) getNet("BaseNet");
    baseNet.closeInputFile();
    baseNet.openInputFile();

    //baseNet.printWeights();

    //move to the next phoneme pattern or turn off phoneme input
    speechNet phonemeNet = (speechNet) getNet("PhonemeNet");
    //if (true) {//to test
    if (speechCANT23.epoch > 120) {//to train
      phonemeNet.setNeuronsToStimulate(0);
      baseNet.setLearningOn(0);
      System.out.print("Test ");
      return;
    }
    /*    else if (speechCANT23.epoch > 120) 
      baseNet.setLearningRate((float)0.0005);
    */
    

    int newPatternNum = phonemeNet.getCurrentPattern()+1;
    newPatternNum = newPatternNum%phonemeNet.getTotalPatterns();
    phonemeNet.setCurrentPattern(newPatternNum);
     
    //CANT23.isRunning = false;
  }

  public void printExpName () {
    System.out.println("Speech Recognition 1 ");
  }

  public int aCount=0;
  public int eCount=0;
  public int uCount=0;
  public void measure (int CANTStep) {
//    System.out.println("measure " + CANTStep + " " + aCount + " " + eCount + 
//                                               " " + uCount);
    speechNet phonemeNet = (speechNet) getNet("PhonemeNet");
    for (int i = 0; i < 200; i++) {
      if (phonemeNet.neurons[i].getFired()) aCount++;
      if (phonemeNet.neurons[i+200].getFired()) eCount++;
      if (phonemeNet.neurons[i+400].getFired()) uCount++;
    }
  }
}


